local SoulTeleporter = Class(function(self, inst)
    self.inst = inst
	self.boundTo = nil
end)

--Maybe in the future add sanity gameplay to this mod
--function SoulTeleporter:OnUpdate(dt)
	--pickuper.components.sanity:DoDelta( -TUNING.REVIVER_CRAFT_SANITY_PENALTY )
--end

function SoulTeleporter:OnSave()
	--print("SoulTeleporter:OnSave")
	return {boundToUserid = self.boundToUserid}
end

function SoulTeleporter:OnLoad(data)
	if data.boundToUserid ~= nil then
        self.boundToUserid = data.boundToUserid
    end
end


function SoulTeleporter:OnPickup(pickuper)
	if self.boundToUserid == nil then
		--print("SoulTeleporter created")
		self.boundToUserid = pickuper.Network:GetUserID()
	end
end


function SoulTeleporter:TeleportAction(doer)	
	if self.boundToUserid ~= nil then
		for k,v in pairs(AllPlayers) do
			if self.boundToUserid == v.Network:GetUserID() and self.boundToUserid ~= doer.Network:GetUserID() then
				--print("Teleport ", doer.Network:GetUserID(), " to ", self.boundToUserid)
				
				local tp_pos = v:GetPosition() + Vector3( GetRandomWithVariance(0,2), 0.0, GetRandomWithVariance(0,2) )
				doer.Physics:Teleport(tp_pos:Get())
				
				local tp_sayings = { "Shazam!", "Poof!", "Alakazam!", "Presto-Teleporto!"}
				
				local say_index = math.floor(GetRandomMinMax(0,#tp_sayings)) + 1
				doer.components.talker:Say( tp_sayings[say_index] )

				local puff = SpawnPrefab("small_puff")
				puff.Transform:SetPosition(tp_pos:Get())
				
				return true
			end
		end
	end
	return false
end

return SoulTeleporter